两数之和 -- 力扣

Posted 满天星!

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了两数之和 -- 力扣相关的知识,希望对你有一定的参考价值。

两数之和 – 力扣

题目链接

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。

你可以按任意顺序返回答案。

示例 1:

输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1]

示例 2:

输入:nums = [3,2,4], target = 6
输出:[1,2]

示例 3:

输入:nums = [3,3], target = 6
输出:[0,1]

方法一:(暴力枚举) O(n2)

两重循环枚举下标 i , j ,然后判断 nums[i]+nums[j] 是否等于 target。

AC代码

class Solution 
public:
    vector<int> twoSum(vector<int>& nums, int target) 
      vector<int>res;
      for(int i=0;i<nums.size();i++)
      
          for(int j=0;j<i;j++)
          
              if(nums[i]+nums[j]==target)
              
                  res=vector<int>(i,j);
                  break;
              
          
          if(res.size()>0) break;
      
      return res;
    
;

方法二:哈希表 O(n)
使用哈希表 unordered_map<int, int> hash.
遍历 nums 数组
1.判断 target−nums[i]是否在哈希表中
2.将 nums[i]插入哈希表中
保证有且仅有一组解

AC代码

class Solution 
public:
    vector<int> twoSum(vector<int>& nums, int target)
    
        vector<int> res;
        unordered_map<int,int> hash;
        for (int i = 0; i < nums.size(); i ++ )
        
            int t = target - nums[i];
            if (hash.count(t)) //找到一组解
            
                res = vector<int>(hash[t], i);
                break;
            
            hash[nums[i]] = i;
        
        return res;
    
;

如果觉得写的还不错,点个赞吧 ^ v ^

以上是关于两数之和 -- 力扣的主要内容,如果未能解决你的问题,请参考以下文章

力扣1两数之和

力扣1两数之和(Java)

力扣1两数之和(简单)

力扣 两数之和

力扣:两数之和

力扣:两数之和